module siebensegment
(
    input clk,
    input [3:0] data0,
    input [3:0] data1,
    input [3:0] data2,
    input [3:0] data3,
    output [6:0] segmente,
    output [3:0] anode
);

//Taktfrequenz fr Segment-Umschaltung
parameter w = 15;
wire [w-1:0] count_clkdivide;
counter #( .width(w) ) counter_clkdivide
(
    .clk(clk),
    .count(count_clkdivide)
);

// Multiplexer Steuersignal
wire [1:0] count_digits;
counter #( .width(2) ) counter_digits
(
    .clk(count_clkdivide[w-1]),
    .count(count_digits)
);

// Daten Multiplexer
wire [3:0] data_to_siebensegment;
assign data_to_siebensegment = (count_digits == 2'd0 ? data0 :
                               (count_digits == 2'd1 ? data1 :
                               (count_digits == 2'd2 ? data2 :
                               (count_digits == 2'd3 ? data3 :
                                4'bzzzz ))));

//Daten zu 7-Seg Dekoder
siebensegment_dekoder dekoder
(
    .code(data_to_siebensegment),
    .segmente(segmente)
);

// Segment Select Multiplexer
assign anode = (count_digits == 2'd0 ? 4'b0111 :
               (count_digits == 2'd1 ? 4'b1011 :
               (count_digits == 2'd2 ? 4'b1101 :
               (count_digits == 2'd3 ? 4'b1110 :
                4'bzzzz ))));

endmodule

