module tastenzaehler_entprell_top
(
    input clk,
    input [3:0] taste,
    output [6:0] segmente,
    output [3:0] anode
);

wire [15:0] count;
wire [3:0] taste_entprellt;

genvar i;
generate for (i=0; i<4; i=i+1)
 begin: loop_name
		entpreller #(.max_count(250000)) entprell // 250000 == 5 ms
		(
			 .clk(clk),
			 .taste_in(taste[i]),
			 .taste_entprellt(taste_entprellt[i])
		);

		tastenzaehler zaehler
		(
			 .clk(clk),
			 .taste(taste_entprellt[i]),
			 .count(count[(i+1)*4-1:i*4])
		);
 end
endgenerate
 
siebensegment mysiebensegment
(
    .clk(clk),
    .data0(count[3:0]),
    .data1(count[7:4]),
    .data2(count[11:8]),
    .data3(count[15:12]),
    .segmente(segmente),
    .anode(anode)
);

endmodule

